/*
Copyright (c) 2004 EarthLink, Inc.
All rights reserved.

FPeer Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions 
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*
SharedFile.java
*/

package net.earthlink.research.p2p;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.FileNotFoundException;

/**
*
* @author Mark Petrovic
*/
public class SharedFile {

   private   final char[]  toHex = {'0','1','2','3','4','5','6','7',
                                    '8','9','a','b','c','d','e','f'};
   private   String        directory;
   public    String        fileName;
   protected String        digest;
   public    int           size;
   public    File          file;

   //------------------------------

   public SharedFile(String directory, String fileName) {
      File            f;
      FileInputStream fis;
      byte[]          b    = null;
      byte            bid[];

      this.directory = directory;
      this.fileName  = fileName;

      f    = new File(directory + "/" + fileName);
      size = (int )f.length();

      this.file      = f;

      try {
         fis  = new FileInputStream(f);
         b    = new byte[size];
         fis.read(b);
         bid    = MessageDigest.getInstance("MD5").digest(b);
         digest = toHexString(bid);
      } catch (FileNotFoundException e) {
         e.printStackTrace();
      } catch (IOException e) {
         e.printStackTrace();
      } catch (NoSuchAlgorithmException e) {
         e.printStackTrace();
      }

   }

   //------------------------------

   private String toHexString(byte[] b) {
      int pos = 0;
      char[] c = new char[b.length * 2];
      for (int i = 0; i < b.length; i++) {
         c[pos++] = toHex[(b[i] >> 4) & 0x0F];
         c[pos++] = toHex[b[i] & 0x0f];
      }
      return new String(c);
   }

   public String getName() {
      return fileName;
   }

   // remove the file from the filesystem
   public void remove() {
      try {
         file.delete();
      }
      catch (SecurityException e) {
         e.printStackTrace();
      }
   }
}
