/*
Copyright (c) 2004 EarthLink, Inc.
All rights reserved.

FPeer Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions 
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*
Subscriber.java
*/

package net.earthlink.research.p2p;

import javax.sip.Dialog;
import javax.sip.address.SipURI;
import javax.sip.message.Response;

/**
*
* @author Mark Petrovic
*/
public class Subscriber {

   private long     expiresAt;
   private SipURI   subscriberURI;
   private Response okSent;
   private Dialog   dialog;
   private String   userAtHost;

   //-----------------------------------------------------------------
   public Subscriber(SipURI uri, Response response, Dialog d, long expiresAt ) {
      StringBuffer  sb;

      subscriberURI = uri;
      okSent         = response;
      dialog         = d;
      this.expiresAt = expiresAt;

      sb = new StringBuffer();
      sb.append(subscriberURI.getUser());
      sb.append("@");
      sb.append(subscriberURI.getHost());
      userAtHost = sb.toString();
   }

   //-----------------------------------------------------------------
   public boolean equals(SipURI uri) {
      StringBuffer  sb;

      sb = new StringBuffer();
      sb.append(uri.getUser());
      sb.append("@");
      sb.append(uri.getHost());

      return sb.toString().equalsIgnoreCase(userAtHost);
   }

   //-----------------------------------------------------------------
   public boolean equalsHost(String s) {
      return subscriberURI.getHost().equalsIgnoreCase(s);
   }

   //-----------------------------------------------------------------
   public long getExpiresAt() {
      return expiresAt;
   }

   //-----------------------------------------------------------------
   public SipURI getURI() {
      return subscriberURI;
   }

   //-----------------------------------------------------------------
   public Dialog getDialog() {
      return dialog;
   }

   //-----------------------------------------------------------------
   public String getHost() {
      return subscriberURI.getHost();
   }
}
