/*
Copyright (c) 2004 EarthLink, Inc.
All rights reserved.

FPeer Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions 
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

// DownloadTab.java

package net.earthlink.research.p2p.ui;

import java.util.Hashtable;
import java.util.Iterator;
import java.util.Observable;
import java.util.Vector;

import java.awt.BorderLayout;

import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JScrollPane;
import javax.swing.table.DefaultTableModel;

import net.earthlink.research.fsp.FSPclient;

/**
*
* @author Mark Petrovic
*/
public class DownloadTab extends JPanel {

   ROTable           table;
   JScrollPane       scrollPane;
   Vector            colNames;
   Hashtable         progBarHash;
   DefaultTableModel model;

   public DownloadTab() {
      colNames = new Vector();
      colNames.add("Filename");
      colNames.add("Size");
      colNames.add("% complete");

      table = new ROTable(new Vector(), colNames);

      //System.err.println("TableModel class:  " + table.getModel().getClass().getName());
      model = (DefaultTableModel ) table.getModel();
      table.getColumnModel().getColumn(2).setCellRenderer(new DownloadTableRenderer());
 
      scrollPane = new JScrollPane(table);

      setLayout(new BorderLayout());
      add (scrollPane, BorderLayout.CENTER);

      progBarHash   = new Hashtable();
   }

   public void addEntry(FSPclient client, String fileName, int fileSize) {
      Vector                  v;    
      CellProgressBar         progBar;

      progBar = new CellProgressBar(fileSize);

      progBarHash.put(client, progBar);

      v = new Vector();
      v.add(fileName);
      v.add(Integer.toString(fileSize));
      v.add(progBar);  

      model.addRow(v);
      model.fireTableDataChanged();
   }

   public void updateDownload(Observable observable, Object o) {
      CellProgressBar pb;

      pb = (CellProgressBar )progBarHash.get(observable);
      pb.setValue( ( (Integer )o ).intValue() );

      model.fireTableDataChanged();
   }
}
