/*
Copyright (c) 2004 EarthLink, Inc.
All rights reserved.

FPeer Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions 
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

// SharedTab.java

package net.earthlink.research.p2p.ui;

import java.util.Iterator;
import java.util.Vector;

import java.awt.BorderLayout;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.table.DefaultTableModel;

import net.earthlink.research.p2p.FPeer;
import net.earthlink.research.p2p.SharedFile;

/**
*
* @author Mark Petrovic
*/
public class SharedTab extends JPanel {

   ROTable     table;
   JScrollPane scrollPane;
   Vector      colNames;
   Vector      rows;
   SharedFile  shared;

   public SharedTab() {
      colNames = new Vector();
      colNames.add("Filename");
      colNames.add("Size");

      rows = new Vector();
      for( Iterator i = FPeer.fpeer.shareList.iterator(); i.hasNext(); ) {
         Vector v = new Vector();
         shared = (SharedFile )i.next();
         v.add(shared.fileName);
         v.add(Integer.toString(shared.size));
         rows.add(v);
      }

      table      = new ROTable(rows,colNames);
      scrollPane = new JScrollPane(table);

      setLayout(new BorderLayout());
      add (scrollPane, BorderLayout.CENTER);
   }

   public void addSharedFile(SharedFile sharedFile) {
      DefaultTableModel model;
      Vector            v;    

      v = new Vector();
      v.add(sharedFile.fileName);
      v.add(Integer.toString(sharedFile.size));

      model = (DefaultTableModel ) table.getModel();
      model.addRow(v);
      model.fireTableDataChanged();
   }

}
